# This file is part of Signifo Project, see documentation for details


# Manipulate windows.
# args - what to do and in what window
proc Process_window {args} {
        
  set cmd [lindex $args 0]
  set name [lindex $args 1]
  set newname [lindex $args 2]
  set rest [lrange $args 3 end]

  if { $name == "" || $cmd == "" } {
    return
  }
  
  if { $newname == "" } {
    set newname $name
  }

  set exists [winfo exists $newname]
  
  switch $cmd {
    
    show {
      if { $exists == "1" && $name != "." } {
        wm deiconify $name;
        return
      }

      if { [ info procs vTclWindow(pre)$name ] != "" } {
        eval "vTclWindow(pre)$name $newname $rest"
      }
            
      if { [ info procs vTclWindow$name ] != "" } {
        eval "vTclWindow$name $newname $rest"
      }
      
      if { [info procs vTclWindow(post)$name ] != "" } {
        eval "vTclWindow(post)$name $newname $rest"
      }
    }
    
    hide {
      if $exists {
        wm withdraw $newname;
        return
      }
    }
    
    iconify {
      if $exists {
        wm iconify $newname;
        return
      }
    }
    
    destroy {
      if $exists {
        destroy $newname;
        return
      }
    }
  }
}

